<?php
require_once '/var/packages/Spreadsheet/target/phpoffice/word/Autoloader.php';

\PhpOffice\PhpWord\Autoloader::register();
\PhpOffice\PhpWord\Settings::loadConfig();

// ===== for debugging =====================
$ob_file = fopen('/var/log/synoffice.log','a');

function ob_file_callback($buffer)
{
    if ($buffer !== '') {
        global $ob_file;
        fwrite($ob_file, "office import: " . $buffer);
    }
}

ob_start('ob_file_callback');
//======================

function print_log($msg) {
    $line = "doc import@" . Date('Y-m-d H:i:s') . ": $msg\n";
    file_put_contents('/var/log/synoffice.log', $line, FILE_APPEND);
}

function main($argv) {
    $op = $argv[1];
    $src = $argv[2];
    $dst = $argv[3];

    if ('MScheck' === $op) {
        try {
            $ole = new \PhpOffice\PhpWord\Shared\OLERead();
            $ole->read($src);
            foreach ($ole->props as $prop) {
                if ( 'EncryptionInfo' === $prop['name'] ) {
                    exit(1);
                }
            }
        } catch (Exception $e) {
        }
        exit(0);
    } else if ('LOcheck' === $op) {
        try {
            $xmlReader = new \PhpOffice\PhpWord\Shared\XMLReader();
            $xmlReader->getDomFromZip($src, '/META-INF/manifest.xml');
            if ( $xmlReader->getElements('//manifest:encryption-data')->length > 0 ) {
                exit(1);
            }
        } catch (Exception $e) {
        }
        exit(0);
    } else if ('decrypt' === $op) {
        // TODO
    }
}

main($argv);
?>
