
# inject import
from .workbook_outputer import WorkbookOutputer
from .workbook import SynoWorkbook

# pylint: disable=import-outside-toplevel

def __inject_import():
    import openpyxl.workbook.workbook
    from .worksheet import SynoWorksheet
    openpyxl.workbook.workbook.WriteOnlyWorksheet = SynoWorksheet
    import openpyxl.writer.excel
    from .excel_writer import SynoExcelWriter
    openpyxl.writer.excel.ExcelWriter = SynoExcelWriter
    from .workbook_writer import SynoWorkbookWriter
    openpyxl.writer.excel.WorkbookWriter = SynoWorkbookWriter

    from openpyxl.packaging.manifest import DEFAULT_OVERRIDE, Override
    from openpyxl.xml.constants import ARC_SHARED_STRINGS, SHARED_STRINGS
    DEFAULT_OVERRIDE.insert(0, Override(
        "/" + ARC_SHARED_STRINGS, SHARED_STRINGS))

    import openpyxl.worksheet.worksheet
    from .dimensions import SynoRowDimension, SynoColumnDimension
    openpyxl.worksheet.worksheet.RowDimension = SynoRowDimension
    openpyxl.worksheet.worksheet.ColumnDimension = SynoColumnDimension


__inject_import()
