<?php

namespace PhpOffice\PhpPresentation\Writer\ProseMirror;

class ImageBox extends FloatingObject
{
    public $type = 'image_box';

    protected function setContent()
    {
        global $synoTempPath;
        $id = rand();

        $name = $this->phpShape->getName();
        $imgPath = "{$synoTempPath}{$id}:{$name}";
        $handle = fopen($imgPath, 'wb', false);
        if (false !== $handle) {
            fwrite($handle, $this->phpShape->getImageStringData());
            fclose($handle);
        }
        $alpha = $this->phpShape->getAlpha();
        $image = new Shape();
        $image->type = 'image';
        $image->setAttr('alt', $name);
        $image->setAttr('file_id', "$id");
        $image->setAttr('img_transform', $this->getImageTransform());
        if ($alpha < 100) {
          $image->setAttr('opacity', $alpha / 100);
        }
        $image->setShapeType($this->phpShape->getShapeType());

        $this->addContent($image);
    }

    private function getImageTransform()
    {
        $imgTransform = new \stdClass();
        $imgTransform->deg = 0;
        $imgTransform->skewY = 0;
        $imgTransform->height = 1;
        $imgTransform->width = 1;
        $imgTransform->top = 0;
        $imgTransform->left = 0;

        list($cropTop, $cropRight, $cropBottom, $cropLeft) = $this->phpShape->getCrop();
        if (0 === $cropTop && 0 === $cropRight && 0 === $cropBottom && 0 === $cropLeft) {
            return $imgTransform;
        }        

        $width = $this->phpShape->getWidth();
        $height = $this->phpShape->getHeight();
        $orgWidth = $width / (1 - ($cropRight / 100000 + $cropLeft / 100000));
        $orgHeight = $height / (1 - ($cropTop / 100000 + $cropBottom / 100000));

        if (0 != $height) {
            $imgTransform->height = $orgHeight / $height;
            $imgTransform->top = -(($cropTop / 100000) * $orgHeight / $height);
        }
        if (0 != $width) {
            $imgTransform->width = $orgWidth / $width;
            $imgTransform->left = -(($cropLeft / 100000) * $orgWidth / $width);
        }

        return $imgTransform;
    }
}

?>
