<?php

namespace PhpOffice\PhpPresentation\Writer\ProseMirror;

use PhpOffice\PhpPresentation\Style\Alignment;

class PageNumberHolder extends Holder
{
    protected function setContent()
    {
        $slideType = ($this->slide instanceof Master) ? 'master' : 'layout';
        $this->type = 'page_number_' . $slideType . '_holder';

        $shape = new Node();
        $shape->type = 'title_' . $slideType  . '_holder_shape';

        $textBlock = new Node();
        $textBlock->type = 'title_' . $slideType . '_holder_text_block';

        $paragraph = new Paragraph();
        $paragraph->type = 'holder_paragraph';

        $styles = array();
        $phpStyle = $this->phpShape->getListStyle()->getStyleAtLvl(1);
        if (isset($phpStyle)) {
            $paragraph->setStyles($phpStyle);
            $this->slide->getTextStyles($phpStyle->getFont(), $styles);
        }

        if (0 < count($this->phpShape->getParagraphs())) {
            $phpParagraph = $this->phpShape->getParagraph(0);
            $paragraph->setStyles($phpParagraph);
            $this->slide->getTextStyles($phpParagraph->getFont(), $styles);
        }

        $textMark = array();
        $this->slide->styleToMarks($styles, $textMark);
        $paragraph->setAttr('textMark', $textMark);

        $textBlock->addContent($paragraph);
        $shape->addContent($textBlock);
        $this->addContent($shape);
    }
}

?>
