<?php
namespace PhpOffice\PhpWord\Reader\Word2007;

use PhpOffice\PhpWord\PhpWord;
use PhpOffice\PhpWord\Shared\XMLReader;

/**
 * Settings reader
 *
 * @since 0.10.0
 */
class Settings extends AbstractPart
{
    /**
     * Element name settings
     *
     * @var string
     */
    protected $element = 'settings';

    /**
     * Read Settings.xml
     *
     * @param \PhpOffice\PhpWord\PhpWord $phpWord
     * @return void
     */
    public function read(PhpWord $phpWord)
    {
        $xmlReader = new XMLReader();
        $xmlReader->getDomFromZip($this->docFile, $this->xmlFile);

        $evenSetup = $xmlReader->getElements('w:evenAndOddHeaders');
        $phpWord->synoDecorator['place-even'] = ($evenSetup->length > 0);
        $phpWord->synoDecorator['num-even'] = ($evenSetup->length > 0);

        // TODO: other settings
    }
}
