<?php
namespace PhpOffice\PhpWord\Writer\Word2007\Part;

class Comments extends AbstractPart
{
    public function write()
    {
        global $comment;

        $xmlWriter = $this->getXmlWriter();
        $xmlWriter->startDocument('1.0', 'UTF-8', 'yes');
        $xmlWriter->startElement('w:comments');

        // TODO
        // The namespaces are copied from a real-world .docx file generated by Microsoft Word
        // Maybe some of them are not necessary
        $xmlWriter->writeAttribute('xmlns:wpc', 'http://schemas.microsoft.com/office/word/2010/wordprocessingCanvas');
        $xmlWriter->writeAttribute('xmlns:mc', 'http://schemas.openxmlformats.org/markup-compatibility/2006');
        $xmlWriter->writeAttribute('xmlns:o', 'urn:schemas-microsoft-com:office:office');
        $xmlWriter->writeAttribute('xmlns:r', 'http://schemas.openxmlformats.org/officeDocument/2006/relationships');
        $xmlWriter->writeAttribute('xmlns:m', 'http://schemas.openxmlformats.org/officeDocument/2006/math');
        $xmlWriter->writeAttribute('xmlns:v', 'urn:schemas-microsoft-com:vml');
        $xmlWriter->writeAttribute('xmlns:wp14', 'http://schemas.microsoft.com/office/word/2010/wordprocessingDrawing');
        $xmlWriter->writeAttribute('xmlns:wp', 'http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing');
        $xmlWriter->writeAttribute('xmlns:w10', 'urn:schemas-microsoft-com:office:word');
        $xmlWriter->writeAttribute('xmlns:w', 'http://schemas.openxmlformats.org/wordprocessingml/2006/main');
        $xmlWriter->writeAttribute('xmlns:w14', 'http://schemas.microsoft.com/office/word/2010/wordml');
        $xmlWriter->writeAttribute('xmlns:w15', 'http://schemas.microsoft.com/office/word/2012/wordml');
        $xmlWriter->writeAttribute('xmlns:wpg', 'http://schemas.microsoft.com/office/word/2010/wordprocessingGroup');
        $xmlWriter->writeAttribute('xmlns:wpi', 'http://schemas.microsoft.com/office/word/2010/wordprocessingInk');
        $xmlWriter->writeAttribute('xmlns:wne', 'http://schemas.microsoft.com/office/word/2006/wordml');
        $xmlWriter->writeAttribute('xmlns:wps', 'http://schemas.microsoft.com/office/word/2010/wordprocessingShape');
        $xmlWriter->writeAttribute('mc:Ignorable', 'w14 w15 wp14');

        if (is_array($comment)) {
            foreach ($comment as $id => $c) {
                if ($c['type'] === 1) {
                    // Suggestion comment
                    continue;
                }
                $xmlWriter->startElement('w:comment');
                $xmlWriter->writeAttribute('w:id', $c['@id']);
                $xmlWriter->writeAttribute('w:author', '' . $c['author']); // TODO uid to display name
                $xmlWriter->writeAttribute('w:date', $c['date']);
                $xmlWriter->startElement('w:p');
                $xmlWriter->writeAttribute('w14:paraId', $c['paraId']);
                $xmlWriter->startElement('w:r');
                $xmlWriter->startElement('w:annotationRef');
                $xmlWriter->endElement(); // w:annotationRef
                $xmlWriter->endElement(); // w:r
                $xmlWriter->startElement('w:r');
                $xmlWriter->startElement('w:t');
                $xmlWriter->writeRaw($c['text']);
                $xmlWriter->endElement(); // w:t
                $xmlWriter->endElement(); // w:r
                $xmlWriter->endElement(); // w:p
                $xmlWriter->endElement(); // w:comment
            }
        }
        $xmlWriter->endElement(); // w:comments
        return $xmlWriter->getData();
    }
}
