var Emitter = require('component-emitter');

/**
 * Packet types (see https://github.com/socketio/socket.io-protocol)
 */

exports.CONNECT = 0;
exports.DISCONNECT = 1;
exports.EVENT = 2;
exports.ACK = 3;
exports.ERROR = 4;
exports.BINARY_EVENT = 5;
exports.BINARY_ACK = 6;

var errorPacket = {
  type: exports.ERROR,
  data: 'parser error'
};

function Encoder () {}

Encoder.prototype.encode = function (packet, callback) {
  var p = {
    type: packet.type
  };
  if (packet.data) {
    p.data = packet.data;
  }
  if (packet.id !== undefined) {
    p.id = packet.id;
  }
  if (packet.nsp !== undefined && packet.nsp !== '/') {
    p.nsp = packet.nsp;
  }
  return callback([ JSON.stringify(p) ]);
};

function Decoder () {}

Emitter(Decoder.prototype);

Decoder.prototype.add = function (obj) {
  var decoded;
  try {
    decoded = JSON.parse(obj);
    if (decoded && decoded.nsp === undefined) {
      decoded.nsp = '/';
    }
  } catch (e) {
    decoded = errorPacket;
  }
  this.emit('decoded', decoded);
};

Decoder.prototype.destroy = function () {};

exports.Encoder = Encoder;
exports.Decoder = Decoder;
