"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.createHolder=i;exports.createInheritHolder=n;exports.findLayoutHolderTypeId=a;exports.findSlideHolderTypeId=d;exports.HolderAction=void 0;var e=require("./floating_action");var t=require("synoffice-model");var r=require("synoffice-core-utils");var l=require("synoffice-schema-presentation");function i(e,t,r,l){if(r==="page_num"){r="page_number"}let i=`${r}_${t}_holder`;let n;if(r==="page_number"){let r=t==="slide"?i:`title_${t}_holder`;if(t==="slide"){n=e.nodes.page_number.createAndFill();n=e.nodes.paragraph.createAndFill(null,n)}else if(t==="master"){n=e.nodes.holder_paragraph.createAndFill({textAlign:"right"})}n=e.nodes[r+"_text_block"].createAndFill(null,n);n=e.nodes[r+"_shape"].createAndFill(null,n)}return e.nodes[i].createAndFill(l,n)}function n(e,t){let r=e.type;let l;if(r.isMasterHolder){l="layout"}else if(r.isLayoutHolder){l="slide"}else{throw new Error(`Invalid inherited holder type. (${e.type.name})`)}if(!t){t=Object.create(null)}if(!("type_id"in t)){t.type_id="type_id"in e.attrs?e.attrs.type_id:"0"}return i(e.type.schema,l,r.holderType,t)}function o(e,t){let r=e.getHolderByType(t);let l=Object.create(null);for(let e=r.length-1;e>=0;--e){l[r[e].attrs.type_id]=true}return l}function s(e,t){if(e==null){return t}else if(!isNaN(t)){let r=parseFloat(t);if(isNaN(e)||r<parseFloat(e)){return t}}return e}function a(e,t){let r=o(e,t);let l;for(l=0;r[l];++l){}return l.toString()}function d(e,t,r){let l=o(e,r);let i=o(t,r);let n,a;for(let e in i){if(Object.prototype.hasOwnProperty.call(i,e)){n=s(n,e);if(!(e in l)){a=n===e?e:s(a,e)}}}if(a!=null){return a}else if(n!=null){return n}else{return"0"}}class p{constructor(){this.arr=[];this.type={MODIFY:0,INSERT:1,DELETE:2}}insertHolder(e,t){this.arr.push({action:this.type.INSERT,pos:e,node:t})}deleteHolder(e){this.arr.push({action:this.type.DELETE,pos:e})}modifyHolder(e,t){this.arr.push({action:this.type.MODIFY,pos:e,attrs:t})}insertInheritHolder(e,t){this.arr.push({action:this.type.INSERT,pos:e,node:n(t)})}handleHolder(e,t,r){if(t){if(r){return this.modifyHolder(e,{transform:null})}else{if(t.type.isSlideHolder&&!t.textContent.length){return this.deleteHolder(e)}else{return this.modifyHolder(e,{transform:t.state.transform})}}}else{if(r){return this.insertInheritHolder(e,r)}}throw new Error("Should give at least one of holder or inherited holder.")}applyItem(r,l){switch(l.action){case this.type.INSERT:r.insertFloating(l.pos,l.node);break;case this.type.DELETE:r.storeSelection();r.select(t.MultiFloatingSelection.create([r.doc.resolve(l.pos)],true));e.FloatingAction._delete(r);r.restoreSelection();break;case this.type.MODIFY:r.setNodeAttrs(l.pos,l.attrs);break;default:throw new Error("Unexpected action.")}}apply(e){this.arr.sort((e,t)=>e.pos-t.pos);for(let t=this.arr.length-1;t>=0;--t){this.applyItem(e,this.arr[t])}}}class u{static checkInsert(e){let t=l.PathHelper.getContentContainerEndPos(e);if(isNaN(t)){return false}return t}static applyHolders(e,t,l,i){let n=l.getContentContainerNode();let o=t+1+l.getContentContainerOffset();let s=new r.Map;let a=new p;i.getContentContainerNode().forEach(function(e){if(!e.type.isHolder){return}s.set(e,true)});let d=o+1;n.forEach(function(e,t){if(!e.type.isHolder){return}let r=e.type.getInheritHolders(e,i)[0];if(e&&r&&e.type.holderType!==r.type.holderType){r=null}if(r){s.delete(r)}a.handleHolder(d+t,e,r)},this);let u=o+n.nodeSize-1;s.forEach(function(e,t){a.insertInheritHolder(u,t)},this);a.apply(e);return[]}static insertHolder(e,t,n,o,s=Object.create(null)){let p=l.PathHelper.getAbstractSlideNode(t);if(!p){return null}let u=this.checkInsert(t);if(!u){return null}o=(0,r.copyObj)(o);if(p.type.isLayout){if(!("type_id"in o)){o.type_id=a(p,n)}}else if(p.type.isSlide){if(!("type_id"in o)){let t=e.doc.getLayoutNode(p.state.master_id,p.state.layout_id);if(!t){return null}o.type_id=d(p,t,n)}}e.insertFloating(u,i(p.type.schema,p.type.name,n,o));if(!s.skipInheritHolder){this.insertInheritHolder(e,e.doc.resolve(u))}return[u]}static insertInheritHolder(e,t){let r=l.PathHelper.getLayoutNode(t);if(!r){return null}let i=l.PathHelper.getHolderNode(t);if(!i){return null}let n=new p;let o=i.type.holderType,s=i.attrs.type_id;e.doc.forEachSlide(r.state.master_id,r.state.layout_id,function(e,t){let r;e.forEachHolderByType(o,s,function(e,l){n.handleHolder(t+1+l,e,i);r=true},this);if(!r){n.insertInheritHolder(t+1+e.getInsertFloatingOffset(),i)}},this);n.apply(e);return[]}static deleteHolder(e,t,r=Object.create(null)){let i=l.PathHelper.getHolderPos(t);if(isNaN(i)){return null}if(!r.skipInheritHolder){this.deleteInheritHolder(e,t)}e.deleteFloating([i]);return[]}static deleteInheritHolder(e,t){let r=l.PathHelper.getAbstractSlideData(t);if(!r){return null}let i=r.node;if(i.type.isSlide){return null}let n=l.PathHelper.getHolderNode(t);if(!n){return null}let o=new p;let s;let a=n.type.holderType,d=n.attrs.type_id;const u=function(e,t){let r=s+t+1;e.forEachHolderByType(a,d,function(e,t){o.handleHolder(r+t,e,null)},this)};if(i.type.isMaster){s=r.pos+1;i.forEachLayout(u,this)}else if(i.type.isLayout){s=0;e.doc.forEachSlide(i.state.master_id,i.state.layout_id,u,this)}o.apply(e);return[]}}exports.HolderAction=u;