"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.CellSelectionHelper=exports.TableIndexStore=void 0;class e{constructor(){this.index_map=Object.create(null);this.row_idx_min;this.row_idx_max;this.col_idx_min;this.col_idx_max}getAt(e,t){if(!(e in this.index_map)){return undefined}if(!(t in this.index_map[e])){return undefined}return this.index_map[e][t]}setAt(e,t,r){if(!(e in this.index_map)){this.index_map[e]=Object.create(null)}this.index_map[e][t]=r;if(isNaN(this.row_idx_min)||e<this.row_idx_min){this.row_idx_min=e}if(isNaN(this.row_idx_max)||e>this.row_idx_max){this.row_idx_max=e}if(isNaN(this.col_idx_min)||t<this.col_idx_min){this.col_idx_min=t}if(isNaN(this.col_idx_max)||t>this.col_idx_max){this.col_idx_max=t}}setRange(e,t,r,i,s){for(let o=e;o<=t;++o){for(let e=r;e<=i;++e){this.setAt(o,e,s)}}}flattenToArray(){let e=[];Object.keys(this.index_map).forEach(t=>{let r=Object.keys(this.index_map[t]);let i=Number(t);r.forEach(r=>{e.push({row_index:i,col_index:Number(r),data:this.index_map[t][r]})})});return e}toPosArray(e){let t=[];let r=e.findData("isTable");let i=r.pos;let s=r.node;s.forEach((e,r,s)=>{if(!(s in this.index_map)){return}let o=this.index_map[s];e.forEach((e,s,l)=>{if(!(l in o)){return}t.push(i+1+r+1+s)})});return t}toResovledPosArray(e){let t=this.toPosArray(e);let r=e.doc;return t.map(e=>r.resolve(e))}forEach(e,t,r){for(let i in this.index_map){let s=this.index_map[i];i=Number(i);for(let o in s){let l=e.call(t,i,Number(o),s[o]);if(r&&l!=null){return l}}}}forEachCell(e,t,r,i){let s,o,l,n;return this.forEach(function(i,a,_){let h=e.maybeChild(i),d=h&&h.maybeChild(a);if(!h||!d){return}if(l===i){o+=h.sizeBetween(n,a);n=a}else{s=l==null?e.offsetAt(i):s+e.sizeBetween(l,i);o=s+1+h.offsetAt(a);l=i;n=a}return t.call(r,d,o,i,a,_)},this,i)}getRectRowSize(){if(isNaN(this.row_idx_max)){return 0}return this.row_idx_max-this.row_idx_min+1}getRectColSize(){if(isNaN(this.col_idx_max)){return 0}return this.col_idx_max-this.col_idx_min+1}getRect(){return{top:this.row_idx_min,bottom:this.row_idx_max,left:this.col_idx_min,right:this.col_idx_max}}}exports.TableIndexStore=e;class t{constructor(e,t,r){let i=e[0].findDepth("isTable");if(isNaN(i)){throw new RangeError("Given resolved pos does not inside table")}this.$table=e[0].shrink(i-1);let s=this.getIndexRectInfo(this.$table,e,t,r);this.sel_rect=s.rect;this.anchor=s.anchor;this.head=s.head;let o=this.$table.self;this.raw_idx_store_=o.getRawIdxStoreByRect(this.sel_rect);this.display_idx_store_=o.getDisplayIdxStoreByRect(this.sel_rect);this.op_idx_store_=o.getOpIdxStoreByRect(this.sel_rect)}getRawResolvedPosArray(){if(!this.raw_resolved_pos_arr_){this.raw_resolved_pos_arr_=this.raw_idx_store_.toResovledPosArray(this.$table)}return this.raw_resolved_pos_arr_}getDisplayResolvedPosArray(){if(!this.display_resolved_pos_arr_){this.display_resolved_pos_arr_=this.display_idx_store_.toResovledPosArray(this.$table)}return this.display_resolved_pos_arr_}getOpResolvedPosArray(){if(!this.op_resolved_pos_arr_){this.op_resolved_pos_arr_=this.op_idx_store_.toResovledPosArray(this.$table)}return this.op_resolved_pos_arr_}get mergedCellResolvedPosArray(){let e=this.getOpResolvedPosArray();return e.filter(e=>{let t=e.self.state;return(t.view_colspan>1||t.view_rowspan>1)&&t.display})}get tableDoms(){return this.$table.self.dom}get cellDoms(){return this.getDisplayResolvedPosArray().map(e=>{return e.self.dom})}isSquare(){let e=Object.keys(this.op_idx_store_.index_map).map(e=>Number(e));if(!e.length){return false}for(let t=1;t<e.length;t++){if(e[t-1]+1!==e[t]){return false}}let t=Object.keys(this.op_idx_store_.index_map[e[0]]).map(e=>Number(e));for(let e=1;e<t.length;e++){if(t[e-1]+1!==t[e]){return false}}for(let r=1;r<e.length;r++){let i=Object.keys(this.op_idx_store_.index_map[e[r]]).map(e=>Number(e));if(i.length!==t.length){return false}for(let e=0;e<t.length;e++){if(i[e]!==t[e]){return false}}}return true}isOnlyOneVisibleCell(){return this.getDisplayResolvedPosArray().length===1}isSingleRow(){let e=Object.keys(this.op_idx_store_);return e.length===1}isSingleCol(){let e=Object.keys(this.op_idx_store_);if(e.length===0){return false}let t=Object.keys(this.op_idx_store_[e[0]]);if(t.length!==1){return false}let r=t[0];for(let t=1;t<e.length;t++){let i=Object.keys(this.op_idx_store_[e[t]]);if(i.length!==1){return false}if(i[0]!==r){return false}}return true}canBeMerged(){return this.isSquare()&&!this.isOnlyOneVisibleCell()}canBeUnmerged(){return this.mergedCellResolvedPosArray.length>0}getIndexRect(e){let t;for(let r of e){let e,i,s,o;e=s=r.index();i=o=r.index(-1);if(t){t.top=Math.min(t.top,i);t.bottom=Math.max(t.bottom,o);t.left=Math.min(t.left,e);t.right=Math.max(t.right,s)}else{t={left:e,top:i,right:s,bottom:o}}}return t}getCornerIndex(e,t,r){return{row:t?e.bottom:e.top,col:r?e.right:e.left}}getAnchorIndex(e,t,r){return this.getCornerIndex(e,t<0,r<0)}getHeadIndex(e,t,r){return this.getCornerIndex(e,t>0,r>0)}getIndexRectInfo(e,t,r,i){let s=e.self;let o=this.getIndexRect(t);let l=this.getAnchorIndex(o,r,i);let n=this.getHeadIndex(o,r,i);l=s.getEnsuredCellIndex(l.row,l.col);n=s.getEnsuredCellIndex(n.row,n.col);o.top=Math.min(l.row,n.row);o.bottom=Math.max(l.row,n.row);o.left=Math.min(l.col,n.col);o.right=Math.max(l.col,n.col);return{rect:o,anchor:l,head:n}}}exports.CellSelectionHelper=t;